## sdl2-compat 2.28.50~git20240124~35695bd+ds

=== CMakeLists.txt ===
# NOTE:  If you installed SDL3 at an unusual place and SDL3Config fails,
#        you can define SDL3_INCLUDE_DIRS on the cmdline.  For example:
#        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]

cmake_minimum_required(VERSION 3.0.0...3.5)
project(sdl2_compat VERSION 2.28.50 LANGUAGES C)

if(POLICY CMP0074)
  # CMP0074: find_package() uses <PackageName>_ROOT variables.
  cmake_policy(SET CMP0074 NEW)
endif()

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
  set(SDL2COMPAT_MAINPROJECT ON)
  set(SDL2COMPAT_SUBPROJECT OFF)
else()
  set(SDL2COMPAT_MAINPROJECT OFF)
  set(SDL2COMPAT_SUBPROJECT ON)
endif()

if(CMAKE_VERSION VERSION_LESS 3.16.0 OR SDL2COMPAT_SUBPROJECT)
  # - CMake versions <3.16 do not support the OBJC language
  # - When SDL is built as a subproject and when the main project does not enable OBJC,
  #   CMake fails due to missing internal CMake variables (CMAKE_OBJC_COMPILE_OBJECT)
  #   (reproduced with CMake 3.24.2)
else()
  if(APPLE)
    enable_language(OBJC)
  endif()
endif()

set(SDL_MAJOR_VERSION ${sdl2_compat_VERSION_MAJOR})
set(SDL_MINOR_VERSION ${sdl2_compat_VERSION_MINOR})
set(SDL_MICRO_VERSION ${sdl2_compat_VERSION_PATCH})
set(SDL_VERSION "${SDL_MAJOR_VERSION}.${SDL_MINOR_VERSION}.${SDL_MICRO_VERSION}")

include(CheckCSourceCompiles)
include(CheckIncludeFile)
include(CheckCCompilerFlag)
include(CheckLanguage)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(GNUInstallDirs)
include("${CMAKE_CURRENT_LIST_DIR}/cmake/CheckCPUArchitecture.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/macros.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/sdlchecks.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/sdlcompilers.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/cmake/sdlplatform.cmake")

# Calculate libtool-compatible SO version
set(SDL_SO_VERSION_MAJOR "0")
if(SDL_MINOR_VERSION MATCHES "[02468]$")
  # Stable branch, 2.24.1 -> libSDL2-2.0.so.0.2400.1
  math(EXPR SDL_SO_VERSION_MINOR "${SDL_MINOR_VERSION} * 100")
  set(SDL_SO_VERSION_MICRO ${SDL_MICRO_VERSION})
else()
  # Development branch, 2.23.1 -> libSDL2-2.0.so.0.2301.0
  math(EXPR SDL_SO_VERSION_MINOR "${SDL_MINOR_VERSION} * 100 + ${SDL_MICRO_VERSION}")
  set(SDL_SO_VERSION_MICRO 0)
endif()
set(SDL_SO_VERSION "${SDL_SO_VERSION_MAJOR}.${SDL_SO_VERSION_MINOR}.${SDL_SO_VERSION_MICRO}")

if(SDL_MINOR_VERSION MATCHES "[02468]$")
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${SDL_MINOR_VERSION} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "${SDL_MICRO_VERSION}")
else()
  math(EXPR SDL_DYLIB_COMPAT_VERSION_MAJOR "100 * ${SDL_MINOR_VERSION} + ${SDL_MICRO_VERSION} + 1")
  set(SDL_DYLIB_COMPAT_VERSION_MINOR "0")
  math(EXPR SDL_DYLIB_CURRENT_VERSION_MAJOR "${SDL_DYLIB_COMPAT_VERSION_MAJOR}")
  set(SDL_DYLIB_CURRENT_VERSION_MINOR "0")
endif()
set(SDL_DYLIB_COMPAT_VERSION_MICRO "0")
set(SDL_DYLIB_CURRENT_VERSION_MICRO "0")

set(SDL_DYLIB_CURRENT_VERSION "${SDL_DYLIB_CURRENT_VERSION_MAJOR}.${SDL_DYLIB_CURRENT_VERSION_MINOR}.${SDL_DYLIB_CURRENT_VERSION_MICRO}")
set(SDL_DYLIB_COMPAT_VERSION "${SDL_DYLIB_COMPAT_VERSION_MAJOR}.${SDL_DYLIB_COMPAT_VERSION_MINOR}.${SDL_DYLIB_COMPAT_VERSION_MICRO}")

option(SDL2COMPAT_TESTS "Enable to build SDL2 test programs" ON)
option(SDL2COMPAT_INSTALL "Enable installing SDL2-compat" ON)
cmake_dependent_option(SDL2COMPAT_INSTALL_CPACK "Create binary SDL2_compat archive using CPack" ${SDL2COMPAT_MAINPROJECT} "SDL2COMPAT_INSTALL" OFF)
cmake_dependent_option(SDL2COMPAT_INSTALL_TESTS "Install test-cases" OFF "SDL2COMPAT_INSTALL;SDL2COMPAT_TESTS" OFF)
option(SDL2COMPAT_STATIC "Enable building static SDL2 link library" OFF)
option(SDL2COMPAT_WERROR "Treat warnings as errors" OFF)
set(SDL2COMPAT_VENDOR_INFO "" CACHE STRING "Vendor name and/or version to add to SDL_REVISION")
set(SDL2COMPAT_FRAMEWORK FALSE)
#FIXME: should SDL2-compat modify vendor_info/revision information?

if(SDL2COMPAT_STATIC AND NOT (CMAKE_SYSTEM_NAME MATCHES "Linux"))
  message(FATAL_ERROR "Static builds are only supported on Linux.")
endif()

SDL_DetectCompiler()
SDL_DetectCPUArchitecture()
SDL_DetectCMakePlatform()
CheckOpenGLES()

if(NOT MSVC AND NOT APPLE AND NOT OPENBSD)
  cmake_push_check_state()
  set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
  check_c_compiler_flag("" HAVE_NO_UNDEFINED)
  cmake_pop_check_state()
  if(HAVE_NO_UNDEFINED)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--no-undefined")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
  endif()
endif()

if(NOT TARGET SDL3::Headers)
  find_package(SDL3 QUIET COMPONENTS Headers)
endif()

if(NOT TARGET SDL3::Headers)
  find_path(SDL3_INCLUDE_DIRS
    NAMES "SDL3/SDL.h"
  )
  if(NOT SDL3_INCLUDE_DIRS)
    message(FATAL_ERROR "Cannot find SDL3 headers: configure with -DCMAKE_PREFIX_PATH=\"/root/to/SDL3\" or -DSDL3_INCLUDE_DIRS=\"/root/to/SDL3/include\"")
  endif()
  add_library(SDL3::Headers INTERFACE IMPORTED)
  set_property(TARGET SDL3::Headers PROPERTY INTERFACE_INCLUDE_DIRECTORIES "${SDL3_INCLUDE_DIRS}")
endif()

find_package(Git)
if(Git_FOUND)
  execute_process(COMMAND
      "${GIT_EXECUTABLE}" describe --always --tags --long
      WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
      RESULT_VARIABLE GIT_REVISION_STATUS
      OUTPUT_VARIABLE GIT_REVISION
      ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  set(GIT_REVISION_STATUS 1)
  set(GIT_REVISION "")
endif()

if(GIT_REVISION_STATUS EQUAL 0)
  if(GIT_REVISION MATCHES "^[0-9a-f]+$")
    # Just a truncated sha1, so prefix it with the version number
    set(SDL_REVISION "SDL-${SDL_VERSION}-g${GIT_REVISION}")
  else()
    # e.g. release-2.24.0-542-g96361fc47
    set(SDL_REVISION "SDL-${GIT_REVISION}")
  endif()
else()
  set(SDL_REVISION "SDL-${SDL_VERSION}-no-vcs")
endif()

if(SDL2COMPAT_VENDOR_INFO)
  set(SDL2COMPAT_REVISION "${SDL_REVISION} (${SDL2COMPAT_VENDOR_INFO})")
else()
  set(SDL2COMPAT_REVISION "${SDL_REVISION}")
endif()

configure_file(include/SDL2/SDL_revision.h.cmake include/SDL2/SDL_revision.h @ONLY)

set(SDL2COMPAT_SRCS
  src/sdl2_compat.c
  src/dynapi/SDL_dynapi.c
)

if(APPLE)
  list(APPEND SDL2COMPAT_SRCS
    "src/sdl2_compat_objc.m"
  )

  find_package(X11)
  if(X11_FOUND)
    include_directories("${X11_INCLUDE_DIR}")
  endif()
  if(POLICY CMP0068)
    cmake_policy(SET CMP0068 NEW)  # on macOS, don't let RPATH affect install_name.
  endif()
endif()

if(WINDOWS_STORE)
  list(APPEND SDL2COMPAT_SRCS
    "src/sdl2_compat_winrt.cpp"
  )
endif()

if(WIN32)
  list(APPEND SDL2COMPAT_SRCS
    "src/version.rc"
  )
endif()

if(APPLE)
  foreach(SOURCE_FILE ${SDL2COMPAT_SRCS})
    get_filename_component(FILE_EXTENSION ${SOURCE_FILE} EXT)
    if(FILE_EXTENSION STREQUAL "m")
      set_property(SOURCE ${SOURCE_FILE} APPEND_STRING PROPERTY COMPILE_FLAGS " -x objective-c")
    endif()
  endforeach()
endif()

add_library(SDL2 SHARED ${SDL2COMPAT_SRCS})
add_library(SDL2::SDL2 ALIAS SDL2)
SDL_AddCommonCompilerFlags(SDL2 WERROR "${SDL2COMPAT_WERROR}")
target_link_libraries(SDL2 PRIVATE $<BUILD_INTERFACE:SDL3::Headers>)
target_include_directories(SDL2
  INTERFACE
    "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>"
    "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include/SDL2>"
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/SDL2>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/SDL2>"
)
target_compile_definitions(SDL2 PRIVATE "SDL2COMPAT_REVISION=\"${SDL2COMPAT_REVISION}\"")
if(TARGET SDL3::SDL3-shared)
  set_property(TARGET SDL2 PROPERTY BUILD_RPATH $<TARGET_FILE_DIR:SDL3::SDL3-shared>)
endif()

set(EXTRA_CFLAGS )
if(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wall")
  check_c_compiler_flag(-fvisibility=hidden HAVE_FVISIBILITY_HIDDEN)
  if(HAVE_FVISIBILITY_HIDDEN AND (APPLE OR UNIX))
    set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -fvisibility=hidden")
  endif()
  check_c_compiler_flag(-Wdeclaration-after-statement HAVE_WDECLARATION_AFTER_STATEMENT)
  if(HAVE_WDECLARATION_AFTER_STATEMENT)
    set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wdeclaration-after-statement")
  endif()
  if(SDL2COMPAT_WERROR)
    check_c_compiler_flag(-Werror=declaration-after-statement HAVE_WERROR_DECLARATION_AFTER_STATEMENT)
    if(HAVE_WERROR_DECLARATION_AFTER_STATEMENT)
      set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Werror=declaration-after-statement")
    endif()
  endif()
endif()

check_include_file("winapifamily.h" HAVE_WINAPIFAMILY_H)
if(HAVE_WINAPIFAMILY_H)
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_HAVE_WINAPIFAMILY_H")
endif()

# This isn't needed for compat libSDL2 who use SDL3 headers.
# SDL2_test and SDL2_main (and the tes programs) still need
# this, because they use SDL2 headers.
check_include_file("immintrin.h" HAVE_IMMINTRIN_H)
if(NOT HAVE_IMMINTRIN_H)
  set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_DISABLE_IMMINTRIN_H")
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_CFLAGS}")
string(STRIP "${CMAKE_C_FLAGS}" CMAKE_C_FLAGS)

if(UNIX AND NOT APPLE)
  target_compile_definitions(SDL2 PRIVATE "_REENTRANT")
  target_link_libraries(SDL2 PRIVATE ${CMAKE_DL_LIBS})
endif()
if(ANDROID)
  target_link_libraries(SDL2 PRIVATE log)
endif()
if(APPLE)
  # !!! FIXME: check OUTPUT_NAME value.
  set_target_properties(SDL2 PROPERTIES COMPILE_DEFINITIONS "_THREAD_SAFE")
  target_link_libraries(SDL2 PRIVATE
    "-Wl,-compatibility_version,${SDL_DYLIB_COMPAT_VERSION}"
    "-Wl,-current_version,${SDL_DYLIB_CURRENT_VERSION}"
    "-Wl,-framework,AppKit"
  )
  set_target_properties(SDL2 PROPERTIES
      OUTPUT_NAME "SDL2-2.0"
      SOVERSION "0"
  )
elseif(UNIX AND NOT ANDROID)
  # !!! FIXME: check OUTPUT_NAME value
  set_target_properties(SDL2 PROPERTIES
    OUTPUT_NAME "SDL2-2.0"
    VERSION "${SDL_SO_VERSION}"
    SOVERSION "${SDL_SO_VERSION_MAJOR}"
  )
elseif(WIN32)
  set_target_properties(SDL2 PROPERTIES DEFINE_SYMBOL "DLL_EXPORT")
  # avoid DLL having 'lib' prefix with MinGW
  set_target_properties(SDL2 PROPERTIES
    OUTPUT_NAME "SDL2"
    PREFIX ""
  )
else()
  set_target_properties(SDL2 PROPERTIES
    VERSION "${PROJECT_VERSION}"
    SOVERSION "0"
    OUTPUT_NAME "SDL2"
  )
endif()

if(MINGW)
  set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FLAGS " -nostdlib")
  if(USE_CLANG)
    if(SDL_CPU_X86)
      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-i386)
    endif()
  else()
    if(SDL_CPU_X86 OR SDL_CPU_ARM32)
      # 32-bit architectures need libgcc for emulating 64-bit operations (e.g. 64-bit division)
      target_link_libraries(SDL2 PRIVATE gcc)
      set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
    endif()
  endif()
endif()
if(WINDOWS_STORE)
  set_target_properties(SDL2 PROPERTIES DEFINE_SYMBOL "SDL_BUILDING_WINRT=1")
  target_compile_options(SDL2 PRIVATE "-ZW")
elseif(MSVC)
  # Don't try to link with the default set of libraries.
  target_compile_options(SDL2 PRIVATE /GS-)
  if(SDL_CPU_X86)  # don't emit SSE2 in x86 builds
    target_compile_options(SDL2 PRIVATE /arch:SSE)
  endif()
  if(NOT MSVC_CLANG AND NOT SDL_CPU_ARM32)
    set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FLAGS " /NODEFAULTLIB")
  endif()
  # Make sure /RTC1 is disabled: (from SDL2 CMake)
  foreach(flag_var
    CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
    CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
    string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
  endforeach(flag_var)
endif()

# !!! FIXME: what needs to be done for sdl2-compat? Look into this.
## SDL2main library...
if(WIN32)
    add_library(SDL2main STATIC src/SDLmain/windows/SDL_windows_main.c)
    target_link_libraries(SDL2main PRIVATE shell32)
else()
    add_library(SDL2main STATIC src/SDLmain/dummy/SDL_dummy_main.c)
endif()
add_library(SDL2::SDL2main ALIAS SDL2main)

=== test/CMakeLists.txt ===
if(NOT (WIN32 OR APPLE OR CYGWIN OR HAIKU OR BEOS))
  find_library(MATH_LIBRARY m)
endif()

set(OpenGL_GL_PREFERENCE GLVND)
find_package(OpenGL COMPONENTS OpenGL)
if(OPENGL_FOUND)
  set(HAVE_OPENGL_DEFINE "HAVE_OPENGL")
  if(WIN32)
    set(OPENGL_gl_LIBRARY "opengl32")
    set(OPENGL_opengl_LIBRARY "opengl32")
  elseif(APPLE)
    set(OPENGL_gl_LIBRARY "-Wl,-framework,OpenGL")
    set(OPENGL_opengl_LIBRARY "-Wl,-framework,OpenGL")
  endif()
endif()

set(RESOURCE_FILES)
set(SDL2COMPAT_TEST_EXECUTABLES)

function(test_program NAME)
  cmake_parse_arguments(args "NONINTERACTIVE" "TIMEOUT" "SRC" ${ARGN})
  if(ANDROID)
    add_library(${NAME} SHARED ${args_SRC})
  else()
    add_executable(${NAME} ${args_SRC})
  endif()
  list(APPEND SDL2COMPAT_TEST_EXECUTABLES ${NAME})
  set(SDL2COMPAT_TEST_EXECUTABLES ${SDL2COMPAT_TEST_EXECUTABLES} PARENT_SCOPE)
  SDL_AddCommonCompilerFlags(${NAME} WERROR "${SDL2COMPAT_WERROR}")
  target_link_libraries(${NAME} PRIVATE SDL2::SDL2main SDL2::SDL2test SDL2::SDL2)
  # Turn off MSVC's aggressive C runtime warnings for the old test programs.
  if(MSVC)
    target_compile_definitions(${NAME} PRIVATE ${HAVE_OPENGL_DEFINE} _CRT_SECURE_NO_WARNINGS _CRT_SECURE_NO_DEPRECATE _CRT_NONSTDC_NO_DEPRECATE)
  elseif(APPLE)
    target_compile_definitions(${NAME} PRIVATE ${HAVE_OPENGL_DEFINE} GL_SILENCE_DEPRECATION=1)
    target_link_libraries(${NAME} PRIVATE "-Wl,-framework,Cocoa")
  else()
    target_compile_definitions(${NAME} PRIVATE ${HAVE_OPENGL_DEFINE})
  endif()
  if(MATH_LIBRARY)
    target_link_libraries(${NAME} PRIVATE ${MATH_LIBRARY})
  endif()
  if(args_NONINTERACTIVE)
    add_test(
      NAME ${NAME}
      COMMAND ${NAME}
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
    set(timeout 10)
    if(args_TIMEOUT)
      set(timeout ${args_TIMEOUT})
    endif()
    set_tests_properties(${NAME}
      PROPERTIES
      ENVIRONMENT "SDL_AUDIODRIVER=dummy;SDL_VIDEODRIVER=dummy"
      TIMEOUT ${timeout}
    )
    if(SDL2COMPAT_INSTALL_TESTS)
      set(exe ${NAME})
      set(installedtestsdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}/installed-tests/SDL2_compat")
      configure_file(template.test.in "${exe}.test" @ONLY)
      install(
        FILES "${CMAKE_CURRENT_BINARY_DIR}/${exe}.test"
        DESTINATION ${CMAKE_INSTALL_DATADIR}/installed-tests/SDL2_compat
      )
    endif()
  endif()
endfunction()

test_program(checkkeys SRC "checkkeys.c")
test_program(checkkeysthreads SRC "checkkeysthreads.c")
test_program(controllermap SRC "controllermap.c" "testutils.c")
test_program(loopwave SRC "loopwave.c" "testutils.c")
test_program(loopwavequeue SRC "loopwavequeue.c" "testutils.c")
test_program(testatomic NONINTERACTIVE SRC "testatomic.c")
test_program(testaudiocapture SRC "testaudiocapture.c")
test_program(testaudiohotplug SRC "testaudiohotplug.c" "testutils.c")
test_program(testaudioinfo SRC "testaudioinfo.c")
test_program(testbounds SRC "testbounds.c")
test_program(testcustomcursor SRC "testcustomcursor.c")
test_program(testdisplayinfo SRC "testdisplayinfo.c")
test_program(testdraw2 SRC "testdraw2.c")
test_program(testdrawchessboard SRC "testdrawchessboard.c")
test_program(testdropfile SRC "testdropfile.c")
test_program(testerror NONINTERACTIVE SRC "testerror.c")
test_program(testevdev NONINTERACTIVE SRC "testevdev.c")
test_program(testfile NONINTERACTIVE SRC "testfile.c")
test_program(testfilesystem NONINTERACTIVE SRC "testfilesystem.c")
test_program(testgamecontroller SRC "testgamecontroller.c" "testutils.c")
test_program(testgeometry SRC "testgeometry.c" "testutils.c")
test_program(testgesture SRC "testgesture.c")
test_program(testhaptic SRC "testhaptic.c")
test_program(testhittesting SRC "testhittesting.c")
test_program(testhotplug SRC "testhotplug.c")
test_program(testiconv SRC "testiconv.c" "testutils.c")
test_program(testime SRC "testime.c" "testutils.c")
test_program(testintersections SRC "testintersections.c")
test_program(testjoystick SRC "testjoystick.c")
test_program(testkeys SRC "testkeys.c")
test_program(testloadso SRC "testloadso.c")
test_program(testlocale NONINTERACTIVE SRC "testlocale.c")
test_program(testlock SRC "testlock.c")
test_program(testmessage SRC "testmessage.c")
test_program(testmouse SRC "testmouse.c")
test_program(testmultiaudio SRC "testmultiaudio.c" "testutils.c")
if(APPLE)
  set(TESTNATIVE_EXTRA "testnativecocoa.m")
elseif(WIN32)
  set(TESTNATIVE_EXTRA "testnativew32.c")
elseif(UNIX AND NOT ANDROID)
  find_package(X11 REQUIRED)
  set(TESTNATIVE_EXTRA "testnativex11.c")
endif()
test_program(testnative SRC "testnative.c" "testutils.c" "${TESTNATIVE_EXTRA}")
test_program(testoverlay2 SRC "testoverlay2.c" "testutils.c" "testyuv_cvt.c")
test_program(testplatform NONINTERACTIVE SRC "testplatform.c")
test_program(testpower NONINTERACTIVE SRC "testpower.c")
test_program(testqsort NONINTERACTIVE SRC "testqsort.c")
test_program(testrelative SRC "testrelative.c")
test_program(testrendercopyex SRC "testrendercopyex.c" "testutils.c")
test_program(testrendertarget SRC "testrendertarget.c" "testutils.c")
test_program(testresample SRC "testresample.c")
test_program(testrumble SRC "testrumble.c")
test_program(testscale SRC "testscale.c" "testutils.c")
test_program(testsem SRC "testsem.c")
test_program(testsensor SRC "testsensor.c")
test_program(testshape SRC "testshape.c")
test_program(testsprite2 SRC "testsprite2.c" "testutils.c")
test_program(testspriteminimal SRC "testspriteminimal.c" "testutils.c")
test_program(teststreaming SRC "teststreaming.c" "testutils.c")
test_program(testsurround SRC "testsurround.c")
test_program(testthread NONINTERACTIVE TIMEOUT 40 SRC "testthread.c")
test_program(testtimer NONINTERACTIVE TIMEOUT 60 SRC "testtimer.c")
test_program(testurl SRC "testurl.c")
test_program(testver NONINTERACTIVE SRC "testver.c")
test_program(testviewport SRC "testviewport.c" "testutils.c")
test_program(testvulkan SRC "testvulkan.c")
test_program(testwm2 SRC "testwm2.c")
test_program(testyuv SRC "testyuv.c" "testyuv_cvt.c")
test_program(torturethread SRC "torturethread.c")
test_program(testgl2 SRC "testgl2.c")
if(HAVE_OPENGLES)
  test_program(testgles SRC "testgles.c")
  if(ANDROID)
    target_link_libraries(testgles PRIVATE GLESv1_CM)
  endif()
endif()
if(HAVE_OPENGLES_V2)
  test_program(testgles2 SRC "testgles2.c")
  test_program(testgles2_sdf SRC "testgles2_sdf.c" "testutils.c")
  if(ANDROID)
    target_link_libraries(testgles2 PRIVATE GLESv2)
    target_link_libraries(testgles2_sdf PRIVATE GLESv2)
  endif()
endif()

test_program(testautomation NONINTERACTIVE TIMEOUT 120
  SRC
    "testautomation.c"
    "testautomation_audio.c"
    "testautomation_guid.c"
    "testautomation_main.c"
    "testautomation_platform.c"
    "testautomation_sdltest.c"
    "testautomation_syswm.c"
    "testautomation_hints.c"
    "testautomation_math.c"
    "testautomation_rect.c"
    "testautomation_stdlib.c"
    "testautomation_subsystems.c"
    "testautomation_timer.c"
    "testautomation_clipboard.c"
    "testautomation_joystick.c"
    "testautomation_mouse.c"
    "testautomation_render.c"
    "testautomation_video.c"
    "testautomation_events.c"
    "testautomation_keyboard.c"
    "testautomation_pixels.c"
    "testautomation_rwops.c"
    "testautomation_surface.c"
)

if(OPENGL_FOUND)
  if(CMAKE_VERSION VERSION_LESS 3.10 OR NOT OPENGL_opengl_LIBRARY)
    target_link_libraries(testgl2 PRIVATE ${OPENGL_gl_LIBRARY})
  else()
    target_link_libraries(testgl2 PRIVATE ${OPENGL_opengl_LIBRARY})
  endif()
endif()

foreach(fname
    "axis.bmp"
    "button.bmp"
    "controllermap.bmp"
    "controllermap_back.bmp"
    "icon.bmp"
    "moose.dat"
    "sample.bmp"
    "sample.wav"
    "testgles2_sdf_img_normal.bmp"
    "testgles2_sdf_img_sdf.bmp"
    "testyuv.bmp"
    "unifont-13.0.06.hex"
    "utf8.txt")
  list(APPEND RESOURCE_FILES "${fname}")
  file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/${fname}" DESTINATION "${CMAKE_BINARY_DIR}")
endforeach()

if(SDL2COMPAT_INSTALL_TESTS)
  install(
    TARGETS ${SDL2COMPAT_TEST_EXECUTABLES}
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/installed-tests/SDL2_compat
  )
  install(
    FILES ${RESOURCE_FILES}
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/installed-tests/SDL2_compat
  )
endif()

check_c_compiler_flag(-Wformat HAVE_WFORMAT)
if(HAVE_WFORMAT)
  target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT)
endif()

cmake_push_check_state()
if(HAVE_WFORMAT)
  # Some compilers ignore -Wformat-extra-args without -Wformat
  string(APPEND CMAKE_REQUIRED_FLAGS " -Wformat")
endif()
check_c_compiler_flag(-Wformat-extra-args HAVE_WFORMAT_EXTRA_ARGS)
cmake_pop_check_state()
if(HAVE_WFORMAT_EXTRA_ARGS)
  target_compile_definitions(testautomation PRIVATE HAVE_WFORMAT_EXTRA_ARGS)
endif()

add_custom_target(sdl2compat-build-tests)

check_language(CXX)
if(CMAKE_CXX_COMPILER)
  enable_language(CXX)
  add_library(test_sdl3_prototypes STATIC EXCLUDE_FROM_ALL "test_sdl3_syms.cpp")
  target_link_libraries(test_sdl3_prototypes PRIVATE SDL3::Headers)
  SDL_AddCommonCompilerFlags(test_sdl3_prototypes WERROR TRUE)
  set_target_properties(test_sdl3_prototypes PROPERTIES SUFFIX ".do_not_use")
  # Make sure test_sdl3_prototypes is always out-of-date
  add_custom_command(TARGET test_sdl3_prototypes POST_BUILD COMMAND "${CMAKE_COMMAND}" -E touch "${CMAKE_CURRENT_SOURCE_DIR}/test_sdl3_syms.cpp")
  add_dependencies(sdl2compat-build-tests test_sdl3_prototypes)
endif()

=== debian/changelog ===
sdl2-compat (2.28.50~git20240124~35695bd+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require a compatible SDL3 snapshot
  * Drop patch from previous upload, applied upstream

 -- Simon McVittie <smcv@debian.org>  Wed, 24 Jan 2024 13:51:16 +0000

sdl2-compat (2.28.50~git20240121~1aae3d8+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Make the Maintainer consistent with other SDL packages
  * Bump required SDL3 snapshot to 2024-01-21.
    API changes for spinlocks and haptic feedback, among other things, mean
    that older snapshots are incompatible.
  * Add patch to fix test failure on 32-bit architectures

 -- Simon McVittie <smcv@debian.org>  Tue, 23 Jan 2024 10:30:59 +0000

sdl2-compat (2.28.50~git20240110~c5faaac+ds-1) experimental; urgency=medium

  * New package for experimental (Closes: #1060319)
    - Upstream source based on a git snapshot, there are no releases yet
    - Packaging based on a mixture of sdl12-compat and libsdl2
  * This package is experimental, and must not be uploaded to unstable
    until SDL3 is API- and ABI-stable.
  * Initial Debian delta:
    - d/copyright, d/p/test-Don-t-install-bundled-copy-of-unifont.patch:
      Repack to exclude some unnecessary vendored files from the test suite.
      To the best of my knowledge, everything we exclude is (meant to be)
      Free Software, we just don't want to keep track of the copyright and
      licensing status of files that are irrelevant to Debian.
    - d/p/Avoid-hard-coding-libdir-in-sdl2-config.patch:
      Be multi-arch co-installable
    - d/SDL_config.h, d/rules:
      Install a version of SDL_config.h that is backwards-compatible with
      what SDL2 traditionally provided.
      Upstream sdl2-compat currently uses SDL_config_minimal.h on Unix, but
      that version is missing lots of feature-test macros that games are
      probably relying on. Until this gets resolved upstream, we can avoid
      issues similar to #1039439 and #1012232 by providing our own
      relatively complete SDL_config.h.
    - d/p/test-Disable-audio-test-case-that-fails-in-a-chroot-conta.patch,
      Disable a test case that is not yet working

 -- Simon McVittie <smcv@debian.org>  Wed, 10 Jan 2024 15:12:55 +0000

=== debian/control ===
Source: sdl2-compat
Priority: optional
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders:
 Simon McVittie <smcv@debian.org>,
 Stephen Kitt <skitt@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libgl-dev <!nocheck> <!noinsttest>,
 libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
 libsdl3-dev (>= 3~git20240124~),
 libvulkan-dev <!nocheck> <!noinsttest>,
 libx11-dev <!nocheck> <!noinsttest>,
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/libsdl-org/sdl2-compat
Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
Vcs-Browser: https://salsa.debian.org/sdl-team/sdl2-compat
Rules-Requires-Root: no

Package: libsdl2-compat
Architecture: any
Multi-Arch: same
Depends:
 libsdl3-0 (>= 3~git20240124~),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 2 binary compatibility library wrapping SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 depend or build-depend on this package: please use libsdl2-2.0-0 instead.
 .
 This package only provides the library, in a private location, so
 that it can be co-installed with libsdl2-2.0-0. It is intended for
 testing. To replace libsdl2-2.0-0 entirely, and use the compatibility
 layer with all SDL 2 programs, install libsdl2-compat-shim.

Package: libsdl2-compat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-compat-shim (= ${binary:Version}),
 libsdl3-dev (>= 3~git20240124~),
 pkgconf,
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Conflicts:
 libsdl2-dev,
Provides:
 libsdl2-dev (= ${local:EquivalentVersion}),
Replaces:
 libsdl2-dev,
Description: libsdl2-dev replacement using SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 build-depend on this package: please use libsdl2-dev instead.
 .
 This package provides development files.

Package: libsdl2-compat-shim
Architecture: any
Multi-Arch: same
Depends:
 libsdl2-compat (= ${binary:Version}),
 ${misc:Depends},
Conflicts:
 libsdl2-2.0-0,
Replaces:
 libsdl2-2.0-0,
Provides:
 libsdl2-2.0-0 (= ${local:EquivalentVersion}),
Description: libsdl2-2.0-0 replacement using SDL 3
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 depend or build-depend on this package: please use libsdl2-2.0-0 instead.
 .
 This package replaces libsdl2-2.0-0 with the SDL 3 compatibility
 layer, so that all SDL 2 programs will use it.

Package: libsdl2-compat-tests
Build-Profiles: <!noinsttest>
Section: misc
Architecture: any
Depends:
 libsdl2-compat (>= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: SDL 2 binary compatibility library - tests
 sdl2-compat provides a binary compatible API for programs built
 against SDL 2, but using SDL 3.
 .
 If you are writing new code, please target SDL 3 directly (when it
 becomes stable) instead of using this layer. Debian packages should not
 depend or build-depend on this package.
 .
 This package provides automated and manual test programs.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export SDL_AUDIODRIVER = dummy
export SDL_VIDEODRIVER = dummy

include /usr/share/dpkg/default.mk

ifneq (,$(filter-out experimental UNRELEASED,$(DEB_DISTRIBUTION)))
$(error This version of SDL is not yet suitable for testing/unstable)
endif

built_binaries := $(shell dh_listpackages)
configure_options := \
	-DSDL2COMPAT_STATIC=ON \
	-DSDL2COMPAT_VENDOR_INFO="$(DEB_VENDOR) $(DEB_VERSION)" \
	-DSDL2COMPAT_WERROR=OFF \
	$(NULL)

ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS))$(filter %-tests,$(built_binaries)),nocheck)
configure_options += -DSDL2COMPAT_TESTS=ON
else
configure_options += -DSDL2COMPAT_TESTS=OFF
endif

ifneq ($(filter %-tests,$(built_binaries)),)
configure_options += -DSDL2COMPAT_INSTALL_TESTS=ON
else
configure_options += -DSDL2COMPAT_INSTALL_TESTS=OFF
endif

%:
	dh $@ -Scmake

override_dh_auto_configure:
	mkdir -p obj-$(DEB_HOST_GNU_TYPE)
	echo '*' > obj-$(DEB_HOST_GNU_TYPE)/.gitignore
	dh_auto_configure -- $(configure_options)

override_dh_install:
	rm -f debian/tmp/usr/include/SDL2/SDL_config.h
	dh_install

override_dh_strip:
	dh_strip -plibsdl2-compat-shim --no-automatic-dbgsym
	dh_strip --remaining-packages

override_dh_makeshlibs:
	dh_makeshlibs -plibsdl2-compat -n
	dh_makeshlibs --remaining-packages
	library=$$(cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) && ls -1 libSDL2-2.0.so.0.*) && \
	ln -fns sdl2-compat/$$library debian/libsdl2-compat-shim/usr/lib/$(DEB_HOST_MULTIARCH)/
	ln -fns sdl2-compat/libSDL2-2.0.so.0 debian/libsdl2-compat-shim/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_shlibdeps:
	dh_shlibdeps -lusr/lib/$(DEB_HOST_MULTIARCH)/sdl2-compat

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
	chmod --recursive a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests

override_dh_gencontrol:
	dh_gencontrol -- -Vlocal:EquivalentVersion='2.29~git20240108'

=== debian/watch ===
version=4

# TODO:
#opts="\
#    compression=gzip, \
#    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)//, \
#    downloadurlmangle=s#/releases/tag/#/archive/refs/tags/#;s#((?:pre)?release-?@ANY_VERSION@)$#$1/@PACKAGE@-$2.tar.gz#, \
#    filenamemangle=s#(?:pre)?release-?@ANY_VERSION@#@PACKAGE@-$1.tar.gz#" \
#https://github.com/libsdl-org/@PACKAGE@/tags .*/releases/tag/release-?@ANY_VERSION@
#
# or:
#opts="mode=git" \
#https://github.com/libsdl-org/@PACKAGE@ \
#refs/tags/release-@ANY_VERSION@

opts="\
    mode=git, \
    compression=gzip, \
    dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)(?:\+(?:dfsg|ds)[0-9]*)//, \
    pretty=2.28.50~git%cd~%h+ds" \
https://github.com/libsdl-org/sdl2-compat \
HEAD

## sdl2-compat 2.30.50~git20241004~e094ce8+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
 cmake_minimum_required(VERSION 3.0.0...3.5)
-project(sdl2_compat VERSION 2.28.50 LANGUAGES C)
+project(sdl2_compat VERSION 2.30.50 LANGUAGES C)
 
 if(POLICY CMP0074)
   # CMP0074: find_package() uses <PackageName>_ROOT variables.
@@ -176,16 +176,23 @@
   endif()
 endif()
 
-if(WINDOWS_STORE)
-  list(APPEND SDL2COMPAT_SRCS
-    "src/sdl2_compat_winrt.cpp"
-  )
-endif()
-
 if(WIN32)
   list(APPEND SDL2COMPAT_SRCS
+    "src/sdl2_mslibc.c"
     "src/version.rc"
   )
+endif()
+if(MSVC)
+  if(SDL_CPU_X64)
+    list(APPEND SDL2COMPAT_SRCS
+      "src/sdl2_mslibc_x64.masm"
+    )
+    enable_language(ASM_MASM)
+    set_property(SOURCE "src/sdl2_mslibc_x64.masm" PROPERTY LANGUAGE "ASM_MASM")
+  elseif(SDL_CPU_ARM32 OR SDL_CPU_ARM64)
+    # FIXME: ARM assembler (armasm.exe/armasm64.exe) is NOT ASM_MASM, and does currently not work with CMake
+    # (https://gitlab.kitware.com/cmake/cmake/-/issues/18912)
+  endif()
 endif()
 
 if(APPLE)
@@ -215,6 +222,9 @@
   set_property(TARGET SDL2 PROPERTY BUILD_RPATH $<TARGET_FILE_DIR:SDL3::SDL3-shared>)
 endif()
 
+if(MSVC AND SDL_CPU_X64)
+  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:ASM_MASM>:/nologo>")
+endif()
 set(EXTRA_CFLAGS )
 if(CMAKE_C_COMPILER_ID MATCHES "Clang|GNU")
   set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -Wall")
@@ -296,22 +306,20 @@
     if(SDL_CPU_X86)
       target_link_libraries(SDL2 PRIVATE clang_rt.builtins-i386)
     endif()
+    if(SDL_CPU_X64)
+      target_link_libraries(SDL2 PRIVATE clang_rt.builtins-x86_64)
+    endif()
   else()
-    if(SDL_CPU_X86 OR SDL_CPU_ARM32)
-      # 32-bit architectures need libgcc for emulating 64-bit operations (e.g. 64-bit division)
-      target_link_libraries(SDL2 PRIVATE gcc)
-      set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
-    endif()
-  endif()
-endif()
-if(WINDOWS_STORE)
-  set_target_properties(SDL2 PROPERTIES DEFINE_SYMBOL "SDL_BUILDING_WINRT=1")
-  target_compile_options(SDL2 PRIVATE "-ZW")
-elseif(MSVC)
+    # need libgcc for emulating 64-bit operations (e.g. 64-bit division) or __chkstk_ms()
+    target_link_libraries(SDL2 PRIVATE gcc)
+    set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FALGS " -static-libgcc")
+  endif()
+endif()
+if(MSVC)
   # Don't try to link with the default set of libraries.
-  target_compile_options(SDL2 PRIVATE /GS-)
+  target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:C>:/GS->")
   if(SDL_CPU_X86)  # don't emit SSE2 in x86 builds
-    target_compile_options(SDL2 PRIVATE /arch:SSE)
+    target_compile_options(SDL2 PRIVATE "$<$<COMPILE_LANGUAGE:C>:/arch:SSE>")
   endif()
   if(NOT MSVC_CLANG AND NOT SDL_CPU_ARM32)
     set_property(TARGET SDL2 APPEND_STRING PROPERTY LINK_FLAGS " /NODEFAULTLIB")
@@ -320,16 +328,3 @@
   foreach(flag_var
     CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
     CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
-    string(REGEX REPLACE "/RTC(su|[1su])" "" ${flag_var} "${${flag_var}}")
-  endforeach(flag_var)
-endif()
-
-# !!! FIXME: what needs to be done for sdl2-compat? Look into this.
-## SDL2main library...
-if(WIN32)
-    add_library(SDL2main STATIC src/SDLmain/windows/SDL_windows_main.c)
-    target_link_libraries(SDL2main PRIVATE shell32)
-else()
-    add_library(SDL2main STATIC src/SDLmain/dummy/SDL_dummy_main.c)
-endif()
-add_library(SDL2::SDL2main ALIAS SDL2main)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -56,6 +56,12 @@
       ENVIRONMENT "SDL_AUDIODRIVER=dummy;SDL_VIDEODRIVER=dummy"
       TIMEOUT ${timeout}
     )
+    if(WIN32 AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.27")
+      set_property(TEST ${NAME} APPEND PROPERTY ENVIRONMENT_MODIFICATION "PATH=path_list_prepend:$<TARGET_RUNTIME_DLL_DIRS:${NAME}>")
+      if(TARGET SDL3::SDL3-shared)
+        set_property(TEST ${NAME} APPEND PROPERTY ENVIRONMENT_MODIFICATION "PATH=path_list_prepend:$<TARGET_FILE_DIR:SDL3::SDL3-shared>")
+      endif()
+    endif()
     if(SDL2COMPAT_INSTALL_TESTS)
       set(exe ${NAME})
       set(installedtestsdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}/installed-tests/SDL2_compat")
@@ -160,6 +166,7 @@
     "testautomation.c"
     "testautomation_audio.c"
     "testautomation_guid.c"
+    "testautomation_log.c"
     "testautomation_main.c"
     "testautomation_platform.c"
     "testautomation_sdltest.c"

=== cmake/test/CMakeLists.txt ===
# This cmake build script is meant for verifying the various CMake configuration script.

cmake_minimum_required(VERSION 3.12)
project(sdl_test LANGUAGES C)

include(GenerateExportHeader)

if(ANDROID)
    macro(add_executable NAME)
        set(args ${ARGN})
        list(REMOVE_ITEM args WIN32)
        add_library(${NAME} SHARED ${args})
        unset(args)
    endmacro()
endif()

cmake_policy(SET CMP0074 NEW)

# Override CMAKE_FIND_ROOT_PATH_MODE to allow search for SDL2 outside of sysroot
set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE NEVER)

include(FeatureSummary)

option(TEST_SHARED "Test linking to shared SDL2 library" ON)
add_feature_info("TEST_SHARED" TEST_SHARED "Test linking with shared library")

option(TEST_STATIC "Test linking to static SDL2 library" ON)
add_feature_info("TEST_STATIC" TEST_STATIC "Test linking with static library")

if(TEST_SHARED)
    find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2)
    if(EMSCRIPTEN OR WIN32)
        find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2main)
    endif()
    add_executable(gui-shared WIN32 main_gui.c)
    if(TARGET SDL2::SDL2main)
        target_link_libraries(gui-shared PRIVATE SDL2::SDL2main)
    endif()
    target_link_libraries(gui-shared PRIVATE SDL2::SDL2)
    if(WIN32)
        add_custom_command(TARGET gui-shared POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different "$<TARGET_FILE:SDL2::SDL2>" "$<TARGET_FILE_DIR:gui-shared>"
        )
    endif()

    add_library(sharedlib-shared SHARED main_lib.c)
    target_link_libraries(sharedlib-shared PRIVATE SDL2::SDL2)
    generate_export_header(sharedlib-shared EXPORT_MACRO_NAME MYLIBRARY_EXPORT)
    target_compile_definitions(sharedlib-shared PRIVATE "EXPORT_HEADER=\"${CMAKE_CURRENT_BINARY_DIR}/sharedlib-shared_export.h\"")
    set_target_properties(sharedlib-shared PROPERTIES C_VISIBILITY_PRESET "hidden")

    add_executable(gui-shared-vars WIN32 main_gui.c)
    target_link_libraries(gui-shared-vars PRIVATE ${SDL2_LIBRARIES})
    target_include_directories(gui-shared-vars PRIVATE ${SDL2_INCLUDE_DIRS})

    add_executable(cli-shared main_cli.c)
    target_link_libraries(cli-shared PRIVATE SDL2::SDL2)
    if(WIN32)
        add_custom_command(TARGET cli-shared POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy_if_different "$<TARGET_FILE:SDL2::SDL2>" "$<TARGET_FILE_DIR:cli-shared>"
        )
    endif()

    # SDL2_LIBRARIES does not support creating a cli SDL2 application
    # (it is possible that SDL2main is a stub, but we don't know for sure)
    if(NOT TARGET SDL2::SDL2main)
        add_executable(cli-shared-vars main_cli.c)
        target_link_libraries(cli-shared-vars PRIVATE ${SDL2_LIBRARIES})
        target_include_directories(cli-shared-vars PRIVATE ${SDL2_INCLUDE_DIRS})
    endif()

    add_library(sharedlib-shared-vars SHARED main_lib.c)
    target_link_libraries(sharedlib-shared-vars PRIVATE ${SDL2_LIBRARIES})
    target_include_directories(sharedlib-shared-vars PRIVATE ${SDL2_INCLUDE_DIRS})
    generate_export_header(sharedlib-shared-vars EXPORT_MACRO_NAME MYLIBRARY_EXPORT)
    target_compile_definitions(sharedlib-shared-vars PRIVATE "EXPORT_HEADER=\"${CMAKE_CURRENT_BINARY_DIR}/sharedlib-shared-vars_export.h\"")
    set_target_properties(sharedlib-shared-vars PROPERTIES C_VISIBILITY_PRESET "hidden")
endif()

if(TEST_STATIC)
    find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2-static)
    if(EMSCRIPTEN OR WIN32)
        find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2main)
    endif()
    add_executable(gui-static WIN32 main_gui.c)
    if(TARGET SDL2::SDL2main)
        target_link_libraries(gui-static PRIVATE SDL2::SDL2main)
    endif()
    target_link_libraries(gui-static PRIVATE SDL2::SDL2-static)

    option(SDL_STATIC_PIC "SDL static library has been built with PIC")
    if(SDL_STATIC_PIC OR WIN32)
        add_library(sharedlib-static SHARED main_lib.c)
        target_link_libraries(sharedlib-static PRIVATE SDL2::SDL2-static)
        generate_export_header(sharedlib-static EXPORT_MACRO_NAME MYLIBRARY_EXPORT)
        target_compile_definitions(sharedlib-static PRIVATE "EXPORT_HEADER=\"${CMAKE_CURRENT_BINARY_DIR}/sharedlib-static_export.h\"")
        set_target_properties(sharedlib-static PROPERTIES C_VISIBILITY_PRESET "hidden")
    endif()

    add_executable(gui-static-vars WIN32 main_gui.c)
    target_link_libraries(gui-static-vars PRIVATE ${SDL2MAIN_LIBRARY} ${SDL2_STATIC_LIBRARIES})
    target_include_directories(gui-static-vars PRIVATE ${SDL2_INCLUDE_DIRS})

    add_executable(cli-static main_cli.c)
    target_link_libraries(cli-static PRIVATE SDL2::SDL2-static)

    # SDL2_LIBRARIES does not support creating a cli SDL2 application (when SDL2::SDL2main is available)
    # (it is possible that SDL2main is a stub, but we don't know for sure)
    if(NOT TARGET SDL2::SDL2main)
        add_executable(cli-static-vars main_cli.c)
        target_link_libraries(cli-static-vars PRIVATE ${SDL2_STATIC_LIBRARIES})
        target_include_directories(cli-static-vars PRIVATE ${SDL2_INCLUDE_DIRS})
    endif()
endif()

message(STATUS "SDL2_PREFIX:            ${SDL2_PREFIX}")
message(STATUS "SDL2_INCLUDE_DIR:       ${SDL2_INCLUDE_DIR}")
message(STATUS "SDL2_INCLUDE_DIRS:      ${SDL2_INCLUDE_DIRS}")
message(STATUS "SDL2_LIBRARIES:         ${SDL2_LIBRARIES}")
message(STATUS "SDL2_STATIC_LIBRARIES:  ${SDL2_STATIC_LIBRARIES}")
message(STATUS "SDL2MAIN_LIBRARY:       ${SDL2MAIN_LIBRARY}")
message(STATUS "SDL2TEST_LIBRARY:       ${SDL2TEST_LIBRARY}")

feature_summary(WHAT ALL)

=== debian/changelog ===
sdl2-compat (2.30.50~git20241004~e094ce8+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 prerelease 3.1.3
    - d/control: (Build-)Depend on corresponding libsdl3 prerelease

 -- Simon McVittie <smcv@debian.org>  Fri, 04 Oct 2024 18:05:06 +0100

sdl2-compat (2.30.50~git20240917~cbc8bd0+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 17 Sep 2024 21:08:34 +0100

sdl2-compat (2.30.50~git20240903~8f31681+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot

 -- Simon McVittie <smcv@debian.org>  Tue, 03 Sep 2024 21:29:58 +0100

sdl2-compat (2.30.50~git20240729~b50099f+ds-1) experimental; urgency=medium

  * New upstream snapshot
    - d/control: (Build-)Depend on a corresponding libsdl3 snapshot
    - d/copyright: Update
  * Add a Lintian override for hardening-no-fortify-functions in some tests

 -- Simon McVittie <smcv@debian.org>  Tue, 30 Jul 2024 16:43:48 +0100

sdl2-compat (2.30.50~git20240507~1bee522+ds-1) experimental; urgency=medium

  * New upstream snapshot, corresponding to SDL3 prerelease 3.1.2
    - Depend on a corresponding SDL3 prerelease
  * d/p/Bypass-SDL3-s-version-of-SDL_GetWindowGrab-SDL_SetWindowG.patch:
    Drop, no longer required

 -- Simon McVittie <smcv@debian.org>  Thu, 20 Jun 2024 14:51:47 +0100

sdl2-compat (2.30.50~git20240325~44fec4d+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require SDL3 prerelease 3.1.0
  * d/p/Bypass-SDL3-s-version-of-SDL_GetWindowGrab-SDL_SetWindowG.patch:
    Add patch reinstating compatibility with SDL 3.1.0 prerelease

 -- Simon McVittie <smcv@debian.org>  Tue, 26 Mar 2024 17:16:34 +0000

sdl2-compat (2.30.50~git20240202~4701ef7+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Bump version number to correspond to 2.30.x branch of classic SDL2
  * d/control: Require a corresponding libsdl3

 -- Simon McVittie <smcv@debian.org>  Fri, 02 Feb 2024 15:51:14 +0000

sdl2-compat (2.28.50~git20240128~de26d69+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require a corresponding libsdl3

 -- Simon McVittie <smcv@debian.org>  Mon, 29 Jan 2024 14:46:46 +0000

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  debhelper-compat (= 13),
  libgl-dev <!nocheck> <!noinsttest>,
  libgles-dev [!hurd-any] <!nocheck> <!noinsttest>,
- libsdl3-dev (>= 3~git20240124~),
+ libsdl3-dev (>= 3.1.3~),
  libvulkan-dev <!nocheck> <!noinsttest>,
  libx11-dev <!nocheck> <!noinsttest>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Homepage: https://github.com/libsdl-org/sdl2-compat
 Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
@@ -23,7 +23,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libsdl3-0 (>= 3~git20240124~),
+ libsdl3-0 (>= 3.1.3~),
  ${misc:Depends},
  ${shlibs:Depends},
 Pre-Depends:
@@ -47,7 +47,7 @@
 Multi-Arch: same
 Depends:
  libsdl2-compat-shim (= ${binary:Version}),
- libsdl3-dev (>= 3~git20240124~),
+ libsdl3-dev (>= 3.1.3~),
  pkgconf,
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/watch ===
--- 
+++ 
@@ -17,6 +17,6 @@
     mode=git, \
     compression=gzip, \
     dversionmangle=s/\+(?:git)?[0-9]*(?:\+g[0-9a-f]*)(?:\+(?:dfsg|ds)[0-9]*)//, \
-    pretty=2.28.50~git%cd~%h+ds" \
+    pretty=2.30.50~git%cd~%h+ds" \
 https://github.com/libsdl-org/sdl2-compat \
 HEAD
